(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question02 - test          *)

module Q = Question02

let carre n = n*n
let make_ar u0 r =
  let rec u = function
      0 -> u0
    | n -> r + u (n-1)
  in u

let make_geom u0 q =
  let rec u = function
      0 -> u0
    | n -> q * u (n-1)
  in u

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 2 8 in
      q#beginParse;
      q#init;
      let u0a = q#getN in
      let r = q#getN in
      let uar = make_ar u0a r in
      let u0g = q#getN in
      let qg = q#getN in
      let ugeom = make_geom u0g qg in
	Format.printf "carre x = x*x@.";
	Format.printf "uar (n) = %d + uar (n-1)\nuar (0) = %d@." r u0a;
	Format.printf "ugeom (n) = %d * ugeom (n-1)\nugeom (0) = %d@.@." qg u0g;
	Format.printf "sigma carre %d = %d@." q#getSize (Q.sigma carre q#getSize);
	Format.printf "sigma uar %d = %d@." q#getSize (Q.sigma uar q#getSize);
	Format.printf "sigma ugeom %d = %d@." q#getSize (Q.sigma ugeom q#getSize);
	exit 0;
  end

let _ = main ()
