(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question08 - test          *)

module Q = Question08

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 8 64 in
      q#beginParse;
      q#init;
      Format.printf "Test create:@.";
      let l = Q.create () in
	Format.printf "size l = %d@." (Q.size l);
	Format.printf "Test add:@.";
	for i = 0 to q#getSize - 1 do
	  Q.add q#getN l
	done;
	Format.printf "Test iter (et résultat add):@.";
	Format.printf "@[<v 2>l =@;[@,@[<b 1>" ;
	Q.iter (Format.printf "@;%02d;") l;
	Format.printf "@]@,]@]@.size l = %d@.@." (Q.size l);
	Format.printf "Test is_empty, get_head et drop_head:@.";
	Format.printf "@\n@[<b>";
	while not (Q.is_empty l) do
	  Format.printf "head = %02d;@;" (Q.get_head l);
	  Q.drop_head l;
	  Format.printf "drop_head l (size = %d)@\n" (Q.size l);
	done;
	Format.printf "@]@.";
	exit 0
  end

let _ = main ()
