(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question11 - test          *)

module Q = Question11

let make q n = Array.init (n+1) (
  function 0 -> n
    | _ -> q#getN)

let print pref t =
  Format.printf "@[<v 2>%s(%d) =@;[|@[<b 2>" pref t.(0);
  for i=1 to t.(0) do
    Format.printf "@;%02d;" t.(i)
  done;
  Format.printf "@]|]@]@."

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 11 100 in
      q#beginParse;
      q#init;
      let t = make q q#getSize in
	print "t" t;
	Format.set_margin 20;
	Format.printf "Teste de dfiter:@.@[<b>";
	Q.dfiter (Format.printf "@,(%02d@[<b>@,")
	  (fun _ -> Format.printf "@]@,)") t;
	Format.printf "@]@.";
	exit (0);
  end

let _ = main ()
